from paho.mqtt import client as mqtt_client
import random

broker = 'localhost' #192.168.4.1
port = 1883
client_id = f'python-mqtt-{random.randint(0,100000)}'
#no need for user name and password

def connect_mqtt():
    def on_connect(client, userdata, flags, rc):
        if rc == 0:
            print("Connected to MQTT Broker!")
        else:
            print(f"Failed to connect, return code {rc}\n")

    # Set Connecting Client ID
    client = mqtt_client.Client(client_id)
    #client.username_pw_set(username, password)
    client.on_connect = on_connect
    client.connect(broker, port)
    return client

def publish(client, topic, message):
    print("Sending message...\n")
    result = client.publish(topic, message)
    # result: [0, 1]
    status = result[0]
    if status == 0:
        print(f"Sent message [{message}] for topic [{topic}]")
    else:
        print(f"Failed to send message [{message}] for topic [{topic}]")

def subscribe_custom(client, topic, on_message):
    client.subscribe(topic)
    client.on_message = on_message


def subscribe(client: mqtt_client, topic: str):
	def on_message(client, userdata, message):
		print(f"Received message '{str(message.payload.decode())}' on topic '{message.topic}' with QoS '{str(message.qos)}'")

	subscribe_custom(client, topic, on_message)