import os
import tensorflow as tf

#extending memory usage
os.environ['TF_CPP_MIN_LOG_LEVEL'] = '2'

#tensorflow before version 2.0 requires this call to enable to use the attribute numpy
"""
tf.enable_eager_execution()
#deprecated
"""
tf.compat.v1.enable_eager_execution()

#load mnist object to download the database
mnist = tf.keras.datasets.mnist
#prepare the database into train and test (it download it)
(x_train,y_train),(x_test,y_test) = mnist.load_data()
x_train, x_test = x_train / 255.0, x_test / 255.0

#building the model
model = tf.keras.models.Sequential([
        tf.keras.layers.Flatten(input_shape=(28,28)),
        tf.keras.layers.Dense(128, activation='relu'),
        tf.keras.layers.Dropout(0.2),
        tf.keras.layers.Dense(10)
    ])
#there is a deprecated usage of Keras.
#instructions for updating: if using Keras pass *_constraint arguments to layers


#in order to create a model that returns the probability
"""
probability_model = tf.keras.Sequential([
    model,
    tf.keras.layers.Softmax()
    ])
"""

#calculate the predictions of the training objects
"""
predictions = model(x_train[:1]).numpy()
#TensorFlow before version 2.0 does not have the attribute .numpy()
#need to call the function enable_eager_execution in beginning 
"""
predictions = model(x_train[:1]).numpy()
print("predictions: ")
print(predictions)

"""
tfSession = tf.compat.v1.Session()
tfSession.run(predictions)
"""
#it does not work :( without tf.enable_eager_execution()

#convert the predictions into probabilities
probabilities = tf.nn.softmax(predictions).numpy()
print("probabilities: ")
print(probabilities)

#calculate the error from the predictions and the real object classes
loss_fn = tf.keras.losses.SparseCategoricalCrossentropy(from_logits=True)
loss_value = loss_fn(y_train[:1], predictions).numpy()
print("loss(error):")
print(loss_value)

#adjusts the model parameters to minimize the loss(error)
model.compile(optimizer='adam',
              loss=loss_fn,
              metrics=['accuracy'])
model.fit(x_train, y_train, epochs=5)

#evaluates the performance of the model
"""
model.evaluate(x_test,y_test, verbose=2)
"""